import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import WebFlow.QS.*;
import java.lang.reflect.*;
//import WebFlow.Util.*;
                               
public class SlaveServer extends HttpServlet
{
  private ORB orb;
  private WebFlowContext ws = null;
  PrintWriter out;
  String[] SlaveServers;
  boolean slaveOn = false;
  String UserName;
  String Display;
  String challenge;
  private String cmd_line; 

  private String jroot;
  private String jhost,jport;
  private String jurl;
  private String relMasterIor;
  private String masterIOR;
  private String masterIORurl;
  private String iorDirectory; 
  public String  filename;
  public String  UserContext,host;
  public String  relUserConfigDir; 
  public String  userConfigDir; ///npac/home/webflow/WEBFLOW/BeanContext_2.1/QS/
  private String UCRef;
  public String  ior = "hahaha";
  private WebFlowContext server=null;
  private WebFlowContext uc=null;

  protected void doGet(HttpServletRequest req, HttpServletResponse res)
                       throws ServletException, IOException
  {
        doPost(req, res);
  }


  protected void doPost(HttpServletRequest req, HttpServletResponse res)
                       throws ServletException, IOException
  {
    String temp[] = new String[1];
    UserName = req.getParameter("UserContext");
    Display=req.getParameter("DISPLAY");
    host=req.getParameter("HOST"); 
    challenge=req.getParameter("pw");
    //System.out.println("User: "+UserName+ "aka "+challenge);

    /* Gateway Web server (gatekeeper) */ 
    jhost=req.getParameter("jhost");              
    jport=req.getParameter("jport");              
    jurl="http://"+jhost+":"+jport;   
    jroot=req.getParameter("jroot");             //WebServer's document root
    relMasterIor=req.getParameter("RelMasterIOR");  //master's IOR
    masterIOR=jroot+relMasterIor;
    masterIORurl=jurl+"/"+relMasterIor; 
    iorDirectory=jroot+req.getParameter("RelIorDir");  //modules' IORs
    relUserConfigDir=req.getParameter("UsrConfDir");
    //userConfigDir=jroot+relUserConfigDir;
    userConfigDir=relUserConfigDir;
    filename = jroot+"UserIOR.html";


    cmd_line = 
    "xterm -d "+Display+" -title telnet -e java telnetcontainer "+UserName+" "+challenge+" "+host+" /npac/home/webflow/WEBFLOW/BeanContext_2.2/QS/"+" "+Display+" "+UserName+"."+host;

    System.out.println("-----> "+cmd_line+" <---------");
    

    temp[0] = "";
    res.setContentType("text/html");
    out = res.getWriter();                                                   

  /* get ORB */ 
    String[] args = new String[1];
    args[0]="";
    orb = ORB.init(args, new java.util.Properties());

  /* connect to the "master" user context */

   
   UCRef=req.getParameter("IOR");
   org.omg.CORBA.Object obj = orb.string_to_object(UCRef); 
   server = WebFlowContextHelper.narrow(obj);
   if(server == null) System.out.println("-----> SLAVE IS NULL !!!! ");
   boolean non_existent = true;
   try {
     non_existent = server._non_existent();
   }
   catch(org.omg.CORBA.COMM_FAILURE ex){}
   catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){} 

   if(!non_existent) {
    
      /* check whether the slave already exists */

    slaveOn=false; 

    System.out.println("look for slave...");

    /* note: slaves are called atfer the host name */

    org.omg.CORBA.Object[] SlaveServers2=server.toArray();

    System.out.println("slaves? "+SlaveServers2.length);


    for(int i=0; i<SlaveServers2.length; i++) {    
      try {
         System.out.println("..."+i);
	 BeanContextChild cl=BeanContextChildHelper.narrow(SlaveServers2[i]);
         String SlaveName = cl.getObjectID();
	 System.out.println(SlaveName);
           if(SlaveName.indexOf(host)>-1) {
              slaveOn=true;
              WebFlowContext sl = WebFlowContextHelper.narrow(cl);
	   }
      } catch (Exception exx) {System.out.println(exx);}
    }

    if(slaveOn) {
      System.out.println("The user context is available...");
    }
    else {

      /* oops this part must be updated in both GatewayPortal and here */
      System.out.println("Start a new user context");
      File oldFile = new File(iorDirectory+UserName+".FileBrowser.txt");
      if(oldFile.exists()) {
	System.out.println("oldFile deleted: "+oldFile.delete());
      }   
      File oldFile1 = new File(iorDirectory+UserName+"xmlServer.txt");
      if(oldFile1.exists()) {
	System.out.println("oldFile deleted: "+oldFile1.delete());
      }   

   System.out.println("create a new slave"); 

     /* generate a new config file */

   int iError=createSlaveConf(userConfigDir+UserName+"."+host+".conf");

   try {
     Process p = Runtime.getRuntime().exec(cmd_line);        
    } 
     catch (Exception ex) {
     System.err.println("Error in starting WebFlowServer :"+ex);
    }


     System.out.println("wait till the server is up");
     /* wait till the server is up */
    org.omg.CORBA.Object[] SlaveServers1;
    String[] SlaveServers;

    waitForServer(5000);
  
    for (int j=0; j<100; j++) {
    System.out.println(j);
    SlaveServers1=server.toArray(); 

       System.out.println("How many slaves? "+SlaveServers1.length);
       if(SlaveServers1.length<1) {
          waitForServer(5000);
       } else {
       for(int i=0; i<SlaveServers1.length; i++) {
         BeanContextChild cl=BeanContextChildHelper.narrow(SlaveServers1[i]);
   	   String SlaveName = cl.getObjectID();
	   //	   System.out.println(SlaveName);
           if(SlaveName.indexOf(host)>-1) { 
               slaveOn=true;
	       System.out.println(SlaveName);
               WebFlowContext sl = WebFlowContextHelper.narrow(cl);
	   }
           if(slaveOn) break;
           waitForServer(500);
       }     
       }
    }

    }
    
    if(slaveOn) {
      System.out.println("slave is on");
      uc=null;
      try {
      String serverName=jhost+"/"+UserName+"./"+host+".";
      System.out.println("connect to server "+serverName);
      org.omg.CORBA.Object ucobj=server.getContext(serverName);
      System.out.println("got ucobj");
      if(ucobj==null) System.out.println("ucobj is null");
        uc=WebFlowContextHelper.narrow(ucobj);
      } catch (Exception e7) {
          uc=null; 
          System.out.println("got exception: cannot get the user context");
          System.out.println(e7);
      }
      if(uc!=null) { 
      System.out.println("user context is OK");

	/* add services */

      FileBrowser fb=(WebFlow.QS.FileBrowser)addService("FileBrowser",host+".FileBrowser");
      System.out.println("FileBrowser added");
  try {
       fb.test();
  } catch (Exception e2) {System.out.println(e2);}    

      FileBrowser xfb=(WebFlow.QS.FileBrowser)addService("FileBrowser","XMLFileBrowser");
      System.out.println("XMLFileBrowser added");
  try {
       xfb.test();
  } catch (Exception e2) {System.out.println(e2);}    


      RemoteFile rf=(WebFlow.QS.RemoteFile)addService("RemoteFile","RemoteFile");
      System.out.println("RemoteFile added");
  try {
       rf.test();
  } catch (Exception e2) {System.out.println(e2);}    
    
      WebFlow.QS.MoveFile mf=(WebFlow.QS.MoveFile)addService("MoveFile","MoveFile");
      System.out.println("MoveFile added");
  try {
       mf.test();
  } catch (Exception e2) {System.out.println(e2);}    
    



    System.out.println("slave completed successfully");
    res.setContentType("text/html");
    out.println("<html>");
    out.println("<body bgcolor=\"white\">");
    out.println("slave "+UserName+"/"+host+" sucessfully created>");   
    out.println("</body>");
    out.println("</html>");
    out.flush();
    System.out.println("servlet SlaveServer completed");
    out.close();

      }
      else {
       out.println("Sorry, connot connect to your context");
      }
    } 
    else {
      System.out.println("slave is not responding!");
      out.println("Sorry, cannot access your context");
    }
   }
    else {
      System.out.println("UserContext is not responding!");
      out.println("Sorry, your UserContext is down!");
    }
 //out.close(); 
}

                              
  public String getServletInfo()
  {
  return "By T. Haupt";
  }

    public synchronized void waitForServer(long delay){
        System.err.println("waiting...");
        try {
           wait(delay);
        } catch(InterruptedException e){
                 System.out.println("Intrrupted exc :"+e);
        }
    }


  int createSlaveConf(String fname) {
    int result=0;
    String idlFile="/npac/home/webflow/WEBFLOW/BeanContext_2.2/QS/qs.idl";
    try {
    FileWriter fw = new FileWriter(fname);
    fw.write("ServerName="+host+".\n");
    fw.write("File=none\n");
    fw.write("URL="+masterIORurl+"\n");
    fw.write("PARENT="+jhost+"/"+UserName+".\n");
    fw.write("Modules:===================\n");
    fw.write("FileBrowser "+idlFile+" WebFlow.QS.FileBrowserImp\n");
    fw.write("EditFile "+idlFile+" WebFlow.QS.EditFileImp\n");
    fw.write("SaveAs "+idlFile+" WebFlow.QS.SaveAsImp\n");
    fw.write("PBS "+idlFile+" WebFlow.QS.PBSimp\n");
    fw.write("GLOBUS "+idlFile+" WebFlow.QS.GLOBUSImp\n");
    fw.write("xmlServer "+idlFile+" WebFlow.QS.xmlServerImp\n");
    fw.write("RemoteFile "+idlFile+" WebFlow.QS.RemoteFileImp\n");
    fw.write("MoveFile "+idlFile+" WebFlow.QS.MoveFileImp\n");
    fw.flush();
    fw.close();
    } catch(IOException ioe) {
        System.out.println(ioe);
        result=5;
    }
    return result;
  }

  org.omg.CORBA.Object addService(String ServiceName, String IORName){
   
      WebFlow.BeanContextChild Service=null;
      org.omg.CORBA.Object ServiceObj=null;
      org.omg.CORBA.Object ServiceObj_old=null;
      boolean ServiceExists = false;

      /* load ServiceHelper class */

      String HelperName = "WebFlow.QS."+ServiceName+"Helper";
      Class Helper = null;
      try {
           Helper = Class.forName(HelperName);
      } catch (ClassNotFoundException cnfe) {
               System.out.println("Can't load "+HelperName);
	     }
      System.out.println("class "+HelperName+" loaded!");

      /* find narrow method */
      Method[] allMethods = Helper.getMethods();
      Class argList[]=null;
      int nmeth = allMethods.length; 
      int nmindx = 0; 
      for(int i=0;i<nmeth;i++) {
         if((allMethods[i].getName()).equals("narrow")) {
              nmindx = i;
              argList = allMethods[i].getParameterTypes();
	 } 
      }
      Method narrow = null;
      try {
         narrow = Helper.getMethod("narrow",argList);
      } catch (NoSuchMethodException nsme) {
         System.out.println("No <<narrow>> method in "+HelperName);
      }  

      System.out.println("method narrow found ...");


      /* IOR exists? */
      String iorFileName = iorDirectory+UserName+"."+IORName+".txt";
      System.out.println("ior file: "+iorFileName);
      File iorFile = new File(iorFileName);
      System.out.println("file object created");
      boolean q = iorFile.exists();
      System.out.println(iorFileName+" exists? "+q);
      if(iorFile.exists()) {
	  /* read IOR */
          System.out.println("file "+iorFileName+" exists");
          String ServiceRef = ReadSTRFromFile(iorFileName);
          System.out.println("returned fromReadSTRFromFile");
          /* convert IOR to CORBA object */
          try {
          ServiceObj_old=orb.string_to_object(ServiceRef);
          }
          catch (Exception e1) {System.out.println("the ior is useless");
                                ServiceExists=false;} 
          System.out.println("returned from string_to_object");

          if(ServiceObj_old == null) {
             System.out.println("ServiceObj_old is null");
             ServiceExists=false;
	  }  
          if(ServiceObj_old != null) {
             /* apply the narrow method to the service object */
             java.lang.Object[] MethodArg = new java.lang.Object[1];
             MethodArg[0]=ServiceObj_old;
             try {
             Service =(WebFlow.BeanContextChild)narrow.invoke(Helper,MethodArg);
             System.out.println("returned from invoke...");
 	     }
             catch (Exception e) {
               Throwable t;
               if(e instanceof InvocationTargetException)
                t = ((InvocationTargetException) e).getTargetException();
               else t=e;
               System.out.println("narrow exited with exception " + t);
               t.printStackTrace();
	     }      
             System.out.println("returned narrow");
	     /* connect to the Service */
             if(Service != null) {
                ServiceExists = true;
        	try {
         System.out.println(ServiceName+": WFserver? "+Service.isWFServer());
	        //Service.test();
                } catch (Exception e2) {ServiceExists=false;}
	     }
	  }
          if(!ServiceExists) {
	    /* delete the obsolete IOR */ 
	     boolean x = iorFile.delete();
             System.out.println("ior deleted - "+x);
	  } 
      }
      else {
        System.out.println("iorFile does not exist");
        ServiceExists = false;
      }   

      if(ServiceExists) {
	/* this is not needed, I guess */
          System.out.println(ServiceName+" exists");
         ServiceObj = ServiceObj_old;
      }
      else {
        /* Service does not exist: create it from scratch */
        System.out.println(ServiceName+" does not exist");
        ServiceObj=uc.addNewModule(ServiceName);
        if(ServiceObj==null) System.out.println("Oops, file browser not found!");
        System.out.println("writting IOR to "+iorFileName);
        try {
         FileWriter fwriter = new FileWriter(iorFileName);
         System.out.println("fwriter created"); 
         if(ServiceObj==null) System.out.println("Oops, file browser not found!");
         if(orb==null) System.out.println("Oops, no orb!");
         String mior = orb.object_to_string(ServiceObj);
         System.out.println("new IOR = "+mior); 
         fwriter.write(mior);
         fwriter.flush();
         fwriter.close();
         System.out.println(iorDirectory+UserName+"."+ServiceName+".txt written");
	} catch (Exception eee){System.out.println(eee+" IORwriter exception");
	}
        /* narrow and test the service */
             
             /* apply the narrow method to the service object */
             java.lang.Object[] MethodArg = new java.lang.Object[1];
             MethodArg[0]=ServiceObj;
             try {
             Service =(WebFlow.BeanContextChild)narrow.invoke(Helper,MethodArg);
             System.out.println("returned from invoke...");
 	     }
             catch (Exception e) {
               Throwable t;
               if(e instanceof InvocationTargetException)
                t = ((InvocationTargetException) e).getTargetException();
               else t=e;
               System.out.println("narrow exited with exception " + t);
               t.printStackTrace();
	     }      
             System.out.println("returned narrow");
	     /* connect to the Service */
             if(Service != null) {
                ServiceExists = true;
        	try {
         System.out.println(ServiceName+": WFserver? "+Service.isWFServer());
                } catch (Exception e2) {ServiceExists=false;
                  System.out.println(e2.toString());}
	     }
             else {System.out.println("Oops: "+ServiceName+" is null");}
      }
    return Service;
  }  
  
  public String ReadSTRFromFile(String masterIOR) 
       //          throws FileNotFoundException, IOException
  {
      //open a file
      FileInputStream theFile;
      BufferedReader fileReader;
      String sObjRef;

      try {
           theFile=new FileInputStream(masterIOR);
           fileReader=new BufferedReader(new InputStreamReader(theFile));
      }
      catch(FileNotFoundException e){
           return "";
      }

      //read a reference string
      try {
        sObjRef=fileReader.readLine();
        System.err.println("Got the reference: "+sObjRef);
      }
      catch (IOException e) {
        return "";
      }
      
      try {
        theFile.close();
        fileReader.close();
      }
      catch (IOException e) {}

      //return the reference string
      return sObjRef;
  }

}







